/**
 * PS4
 * Authors: Logan Tucker and Tucker Simpson
 */

public class BaconGraphLibTest {
    public static void main(String[] args) {
        Graph<String, Integer> test = new AdjacencyMapGraph<String, Integer>();
        test.insertVertex("A");
        test.insertVertex("B");
        test.insertVertex("C");
        test.insertVertex("D");
        test.insertVertex("E");
        test.insertVertex("F");
        test.insertVertex("G");
        test.insertVertex("H");
        test.insertVertex("I");
        test.insertVertex("J");
        test.insertVertex("K");

        test.insertUndirected("A", "B", 0);
        test.insertUndirected("A", "C", 0);
        test.insertUndirected("A", "D", 0);
        test.insertUndirected("D", "H", 0);
        test.insertUndirected("C", "F", 0);
        test.insertUndirected("F", "G", 0);
        test.insertUndirected("B", "E", 0);
        test.insertUndirected("I", "J", 0);


        System.out.println("TEST GRAPH");
        System.out.println(test);
        System.out.println();

        System.out.println("TEST 1");
        Graph<String, Integer> bfsTree = BaconGraphLib.bfs(test, "A");
        System.out.println(BaconGraphLib.averageSeparation(bfsTree, "A"));
        System.out.println(BaconGraphLib.getPath(bfsTree, "G"));
        System.out.println(BaconGraphLib.getPath(bfsTree, "F"));
        System.out.println(BaconGraphLib.getPath(bfsTree, "H"));
        System.out.println(BaconGraphLib.getPath(bfsTree, "I"));

        System.out.println(BaconGraphLib.missingVertices(test, bfsTree));

        // edge case of vertex with one out edge
        System.out.println("TEST 2");
        Graph<String, Integer> bfsTree2 = BaconGraphLib.bfs(test, "I");
        System.out.println(BaconGraphLib.averageSeparation(bfsTree2, "I"));

        // edge case of vertex with zero out edges
        System.out.println("TEST 3");
        Graph<String, Integer> bfsTree3 = BaconGraphLib.bfs(test, "K");
        System.out.println(BaconGraphLib.averageSeparation(bfsTree3, "K"));




    }
}
